UNIT main;

INTERFACE

USES
  gnugettext,
  ExtCtrls,
  ComCtrls,
  StdCtrls,
  Dialogs,
  Classes,
  Controls,
  Forms,
  Windows,
  SysUtils;

CONST
  cInfo = 100;


VAR
  pocet  : Longint;

TYPE
  TForm1 = CLASS (TForm )
    btnClear  : TButton;
    tmrUpdate  : TTimer;
    sbStatus  : TStatusBar;
    btnSave  : TButton;
    saveText  : TSaveDialog;
    cbOnTop  : TCheckBox;
    rteCil  : TRichEdit;
    btnSaveRTF  : TButton;
    saveRTF  : TSaveDialog;
    PROCEDURE PrijemZpravy(VAR Msg  : TMsg; VAR Handled  : Boolean );
    PROCEDURE PridejUdalost(Text  : String );
    PROCEDURE FormCreate(Sender  : TObject );
    PROCEDURE tmrUpdateTimer(Sender  : TObject );
    PROCEDURE btnClearClick(Sender  : TObject );
    PROCEDURE btnSaveClick(Sender  : TObject );
    PROCEDURE btnSaveRTFClick(Sender  : TObject );
  Private
    { Private declarations }
  Public
    { Public declarations }
  END;

VAR
  Form1  : TForm1;

IMPLEMENTATION

VAR
  joined  : String;
  joining  : Boolean;

{$R *.dfm}

PROCEDURE TForm1.PrijemZpravy(VAR Msg  : TMsg; VAR Handled  : Boolean );
VAR
  Zprava  : Pchar;
BEGIN
  IF Msg.message = 1024 + cInfo THEN
  BEGIN
    Zprava := StrAlloc(Msg.wParam + 1 );
    GlobalGetAtomName(Msg.lParam, Zprava, Msg.wParam + 1 );
    GlobalDeleteAtom(Msg.lparam );

    //pokud nespojuju ani nic jinho nedlm
    IF (not joining ) and (Zprava <> '[parted]' ) THEN
    BEGIN
      PridejUdalost(Zprava );
      StrDispose(Zprava );
      Handled := True;
      exit;
    END;
    //konec spojovn
    IF Zprava = '[/parted]' THEN
    BEGIN
      joining := False;
      PridejUdalost(joined );
      joined := '';
    END;
    //prbh spojovn
    IF joining and (Zprava <> '[/parted]' ) THEN
    BEGIN
      joined := joined + String(Zprava );
      StrDispose(Zprava );
    END;
    //zahjen spojovn
    IF Zprava = '[parted]' THEN
    BEGIN
      joined := '';
      joining := True;
    END;
    Handled := True;
  END;
END;


PROCEDURE TForm1.tmrUpdateTimer(Sender  : TObject );
BEGIN
  sbStatus.Panels[0].Text := Format(_('%d records' ), [pocet] );
  IF cbOnTop.Checked THEN
    Form1.FormStyle := fsStayOnTop
  ELSE
    Form1.FormStyle := fsNormal;
END;


PROCEDURE TForm1.PridejUdalost(Text  : String );
VAR
  txt  : String;
BEGIN
  txt := Copy(Text, 1, 3 );
  Delete(Text, 1, 3 );
  IF txt = '[/p' THEN
    exit;
  rteCil.SelAttributes.Color := 0;
  IF txt = '[E]' THEN
    rteCil.SelAttributes.Color := 255;
  IF txt = '[W]' THEN
    rteCil.SelAttributes.Color := 36095;
  rteCil.Lines.Add(txt + ' ' + Text );
  rteCil.SetFocus;
  rteCil.SelStart := rteCil.GetTextLen;
  inc(pocet );
END;


PROCEDURE TForm1.btnClearClick(Sender  : TObject );
BEGIN
  rteCil.Lines.Clear;
  pocet := 0;
END;


PROCEDURE TForm1.btnSaveClick(Sender  : TObject );
VAR
  ext  : String;
  fn  :  String;
BEGIN
  IF saveText.Execute THEN
    TRY
      CASE saveText.FilterIndex OF
        1  :
          ext := '.txt';
        2  :
          ext := '.log';
      END;
      fn := ChangeFileExt(saveText.FileName, ext );
      rteCil.PlainText := True;
      rteCil.Lines.SaveToFile(fn );
      rteCil.PlainText := False;
    EXCEPT
      rteCil.PlainText := False;
      ShowMessage(_('Error while saving to file:' ) + #13#10 + fn );
    END;
END;


PROCEDURE TForm1.btnSaveRTFClick(Sender  : TObject );
VAR
  ext  : String;
  fn  :  String;
BEGIN
  IF saveRTF.Execute THEN
    TRY
      ext := '.rtf';
      fn  := ChangeFileExt(saveRTF.FileName, ext );
      rteCil.Lines.SaveToFile(fn );
    EXCEPT
      ShowMessage(_('Error while saving to RTF:' ) + #13#10 + fn );
    END;
END;


PROCEDURE TForm1.FormCreate(Sender  : TObject );
BEGIN
  TranslateComponent(Self );
  textdomain('debughelper' );
  joined := '';
  joining := False;
  Application.OnMessage := PrijemZpravy;
  pocet  := 0;
END;

END.

